#include "StdAfx.h"
#include "CheckOSD.h"
#include "time.h"
#include  <io.h>
#define TABLE_NAME_Gemini _T("CameraPOSGemini")
#define TABLE_NAME _T("CameraPOS")
#define POS_HEAD_INDEX _T("Pos_Head")
#define POS_HEAD_INDEX_GEMINI _T(":")
#define LOG_NAME _T("CheckPOSInVid")
#define ERROR_LOG_NAME _T("CheckPOSInVid-ERROE")
#define NOT_FIND_IN_DB _T("OSDNotFindInDB")
#define NOT_FIND_IN_VID _T("OSDNotFindInVid")
#define MAX_DIFFERENT_SIZE 100
#include <stdio.h>

CCheckOSD::CCheckOSD(void)
{
   m_isExitThread = FALSE;
   m_exitThread = TRUE;
   m_isStartCheck = FALSE;
   //memset(m_lastTime, 0 ,sizeof(long)*CHANNEL_COUNT);
   memset(m_logFlag, 0 ,sizeof(BOOL)*4);
   memset(m_osdTime, 0 ,sizeof(OSD_TIME_OF_CHANNEL)*CHANNEL_COUNT); 
   memset(m_isCheckDone, 0 ,sizeof(bool)*CHANNEL_COUNT);  
   //------for test----------
   //m_dbRootPath = _T("D:\\PV6\\POSData");
}

CCheckOSD::~CCheckOSD(void)
{
   //if (m_isStartCheck)
   //   StopCheck(); 
}

void CCheckOSD::StartCheck()
{
   AfxBeginThread( ( AFX_THREADPROC )Check, this );
   m_isStartCheck = TRUE;
}

void CCheckOSD::StopCheck()
{
   m_isExitThread = TRUE;
   while(!m_exitThread)
   {
      Sleep(100);
   }
   CompareOSD(m_osdInfoVid, m_osdInfoDB, 0);
   WriteLog(m_logNameW,_T("\n---------------------------------"));
   WriteLog(m_logNameW,_T("channelID,startTime,EndTime,"));
   for ( unsigned int i = 0; i< m_vecOSDChannelID.size(); ++i )
   {
      CString str;
      int channelID = m_vecOSDChannelID[i];
      if ( 0 != m_osdTime[channelID].startTime && 
         0 != m_osdTime[channelID].endTime)
      {
         CTime startTm = CTime(m_osdTime[channelID].startTime);
         CTime endTm = CTime(m_osdTime[channelID].endTime);

         str.Format(_T("%d,%s(%d),%s(%d)"),
            channelID + 1,
            startTm.Format(_T("%Y-%m-%d %H:%M:%S")),
            m_osdTime[channelID].startTime,
            endTm.Format(_T("%Y-%m-%d %H:%M:%S")),
            m_osdTime[channelID].endTime);
         WriteLog(m_logNameW,str);
      }
      else
      {
         str.Format(_T("%d,Not have OSD,Not have OSD"), channelID);
         WriteLog(m_logNameW,str);
      }
   }
}

BOOL CCheckOSD::Inital()
{
   GetLogName();
   //read pv6DB path, POS channel, Postype
   if ( !ReagConfig() )
   {
      return FALSE;
   }

   //if ( !GetRecordPath() )
   //{
   //   return FALSE;
   //}
   return TRUE;

}

UINT CCheckOSD::Check( LPVOID pParam )
{
   CCheckOSD* pThis = ( CCheckOSD* )pParam;
	
   CString headStr[CHANNEL_COUNT] = {0};
   long headFrameTime[CHANNEL_COUNT] = {0};

	pThis->m_exitThread = FALSE;
   pThis->Prepare();
   while( pThis->m_isExitThread != TRUE && pThis->IsCheckDone() != TRUE)
   {    
      pThis->GetOSDInVid(headStr, headFrameTime, pThis->m_osdInfoVid, pThis->m_osdInfoDB );
      pThis->GetOSDInDB(pThis->m_osdInfoDB);
      pThis->CompareOSD(pThis->m_osdInfoVid,pThis->m_osdInfoDB, MAX_DIFFERENT_SIZE);
      if (pThis->m_isExitThread != TRUE && pThis->IsCheckDone() != TRUE)
      {
         Sleep( 10 * 1000);//10s
      }  
   }
	pThis->m_exitThread = TRUE;
   ::SendMessage(pThis->m_hwnd, WM_CHECK_DONE, 0, 0);
   return 0;
}


void CCheckOSD::Prepare()
{
   if ( m_startTime != 0 )
   {
     for (int i = 0; i< CHANNEL_COUNT; ++i)
     {
        m_osdInfoVid[i].startTime = m_startTime;
        m_osdInfoDB[i].startTime = m_startTime;
        m_osdInfoDB[i].endTime = m_startTime;
         
     }
   }  
   else
   {
      time_t currentTime;
      currentTime = time(&currentTime);
      for (int i = 0; i< CHANNEL_COUNT; ++i)
      {
         m_osdInfoVid[i].startTime = (long)currentTime;
         m_osdInfoDB[i].startTime = (long)currentTime;
         m_osdInfoDB[i].endTime = (long)currentTime;
      }  
   }
}

//-------------------------------------------------------
//-------------------Get OSD In vid ---------------------
//-------------------------------------------------------
void CCheckOSD::GetOSDInVid(CString* headStr, long* headFrameTime, 
                            OSDInfo* osdInfoVid, OSDInfo* osdInfoDB)
{
   

   std::map <int, CString>::iterator it;
   GetRecordDBDiskList();
   for (unsigned int j = 0; j< m_vecOSDChannelID.size(); ++j)
   {
      int channelID = m_vecOSDChannelID[j];
      for (unsigned int i = 0; i<m_vecRecordDBPath.size(); ++i)
      {
         sqlite3* pDB = NULL;
         if (InitialDB(m_vecRecordDBPath[i],pDB))
         {
            char sql[256] = {0};
            if ( m_endTime != 0 )
            {
               sprintf_s(sql, 256, "Select tmStart,tmEnd,FileName from ch%d where tmEnd> %d and tmEnd <= %d order by tmEnd",
                  channelID, osdInfoVid[channelID].startTime, m_endTime);
            }
            else
            {
               sprintf_s(sql, 256, "Select tmStart,tmEnd,FileName from ch%d where tmEnd> %d order by tmEnd",
                  channelID, osdInfoVid[channelID].startTime);
            }


            char* szError=0;
            int nRet;
            char** pResults = NULL;
            int nRows = 0;
            int nCols = 0;

            nRet = sqlite3_get_table(pDB, sql, &pResults, &nRows, &nCols, &szError);
            if (nRet == SQLITE_OK)
            {
               for (int i = 1; i<= nRows; ++i )
               {
                  if (m_isCheckDone[channelID])
                  {
                     break;
                  }
                  if ( m_isExitThread )
                  {
                     if (pResults)
                     {
                        sqlite3_free_table(pResults);
                        pResults = NULL;
                     }
                     if (pDB)
                        sqlite3_close(pDB);
                     return;
                  }
                  osdInfoVid[channelID].startTime = _ttol(pResults[i*nCols + 1]);
                  CString fileName = pResults[i*nCols + 2];
                  CString strLog = GetOSDInOneVid(fileName, headStr[channelID], 
                     headFrameTime[channelID], 
                     osdInfoVid[channelID],
                     osdInfoDB[channelID],
                     m_osdTime[channelID],
                     m_isCheckDone[channelID]);
                  WriteLog( m_logNameW, strLog );   
               }
               //m_lastTime[channelID] = osdInfo[channelID].endTime;
            }  
            if (pResults)
            {
               sqlite3_free_table(pResults);
               pResults = NULL;
            }

            if (pDB)
               sqlite3_close(pDB);
         }
      }
      long currentTime;
      currentTime = (long)time(&currentTime);
      if ( currentTime > m_endTime && m_endTime != 0)
      {
         m_isCheckDone[channelID] = true;
      }
   }
}

CString CCheckOSD::GetOSDInOneVid(CString vidPathName, 
                               CString& headStr, 
                               long& headFrameTime, 
                               OSDInfo& osdInfoVid,
                               OSDInfo& osdInfoDB,
                               OSDTimeOfChannel& osdTime,
                               bool& isCheckDone)
{
   Adv_File_Handle hFileHandle;
   CString strLog = vidPathName;
   hFileHandle = AdvSDK_OpenFile((LPSTR)(LPCSTR)vidPathName);
   if ( -1 == hFileHandle )
   {
      return strLog + _T(",Open failed!");
   }
   time_t tmStart;
   time_t tmEnd;
   Adv_Status status = AdvSDK_GetFileTime( hFileHandle, &tmStart, &tmEnd );
   osdInfoDB.endTime = tmEnd;
   
   if ( StatusNoError != status )
   {
      AdvSDK_CloseFile(hFileHandle);
      return strLog + _T(",GetFileTime failed!");
   }
   VIDINFODETAIL vidInfo;
   AdvSDK_GetVidInfoDetail((LPSTR)(LPCSTR)vidPathName,&vidInfo);
   strLog = GetOSDInVidDetail(vidPathName,
                                       vidInfo.pOSDInfo,
                                       vidInfo.pFrameInfo,
                                       vidInfo.lTotalFrameCount,
                                       headStr,
                                       headFrameTime,
                                       osdInfoVid,
                                       osdTime,
                                       isCheckDone);
   AdvSDK_FreeVidInfoDetail(&vidInfo);
   AdvSDK_CloseFile(hFileHandle);
   return strLog;
}

CString CCheckOSD::GetOSDInVidDetail(CString vidName,
                                     char** pOSDInfo,
                                  BYTE** pFrameInfo,
                                  unsigned long lTotalFrameCount, 
                                  CString& headStr, 
                                  long& headFrameTime,
                                  OSDInfo& osdInfoVid,
                                  OSDTimeOfChannel& osdTime,
                                  bool& isCheckDone)
{
   //check time : EndTime is determined by the EndTime of the last vid's last OSD
   CString totalOSD = _T("");
   CString strLog = _T("");
   long firstFrameTime = 0;
   long timePOS = 0;
   long maxInterval = -1;
   long minInterval = 1e7;
   CString strOSDTemp = _T("Test");
   long startIndex = 0;

   if (headStr != _T(""))
   {
      strOSDTemp = headStr;
      totalOSD = strOSDTemp;
      firstFrameTime = headFrameTime;
      headStr = _T("");
   }
   for (unsigned long i = 0; i< lTotalFrameCount; ++i)
   {   
      PFRAMEINFO frameInfo = (PFRAMEINFO)pFrameInfo[i];
      CString strOSD = pOSDInfo[i];
      if (strOSD == strOSDTemp)
      {
         continue;
      }
      if ( -1 != strOSD.Find( m_posHeadIndex ) )
      {
         headStr = _T("");
         if (totalOSD != _T(""))
         {
            //get POS Time,stastic max and min interal
            timePOS = GetPOSTimeInOSD(totalOSD);
            if ( 0 != timePOS )
            {
               long interal = firstFrameTime - timePOS;
               maxInterval = max(interal,maxInterval);
               minInterval = min(interal,minInterval);
               //OSD info push in map
               int nEnd = totalOSD.Find(_T("Pos_End"));
               if (nEnd != -1)
               {
                  totalOSD = totalOSD.Mid(0, nEnd);
               }  
					ExtraInfo extraInfo;
					extraInfo.time = timePOS;
					extraInfo.strLog.Format(_T("%s,%d,%d,%d,"), vidName, timePOS,startIndex, i-1);
					extraInfo.strLog = extraInfo.strLog + totalOSD;
               osdInfoVid.mapOSD.insert(std::pair<CString,ExtraInfo>(totalOSD, extraInfo));
               osdTime.endTime = timePOS - 1;//for the program end
               if ( 0 != m_endTime )
               {
                  if (timePOS > m_endTime)
                  {
                     isCheckDone = TRUE;
                  }
               }
            }
            else
            {
               CString str;
               str.Format(_T("%s,%s,%d,%d,"),vidName, _T("Not Find Time"),startIndex, i-1);
               str = str + totalOSD;
               WriteLog(m_errorDBLog, str);
            }
            
         }
         firstFrameTime = frameInfo->tmTime;
         startIndex = i;
         totalOSD = strOSD;    
      }
      else
      {
         /*if (headStr != _T(""))
         {
            totalOSD = headStr;
            firstFrameTime = headFrameTime;
            headStr = _T("");
         }*/
         /*else */if ( totalOSD != _T("") )
         {
            totalOSD  = totalOSD + strOSD;
         }
      }
      strOSDTemp = strOSD;
   }
   //for the next vid
   headFrameTime = firstFrameTime;
   headStr = totalOSD;

   //for write interval log
   if (maxInterval != -1 && minInterval != 1e7)
   {
      strLog.Format(_T("%s,%d,%d,"), vidName, minInterval, maxInterval);
   }
   else
   {
      strLog.Format(_T("%s,None,None,"), vidName);
   }
   return strLog;  
}


//-------------------------------------------------------
//-------------------Get OSD in DB-----------------------
//-------------------------------------------------------
void CCheckOSD::GetOSDInDB(OSDInfo* osdInfo)
{
   //check time:StartTime is determined by the first (OSD)Check Time in DB
   //because the delay time in DB is smaller than vid
   std::map <int, CString>::iterator it;
   long oneHour_s = 3600;
   GetPV6DBPath();
   for (unsigned int i = 0; i< m_vecOSDChannelID.size(); ++i )
   {
      
      int channelID = m_vecOSDChannelID[i];
      /*if ( m_osdTime[channelID].startTime == 0 )
      {
         m_osdTime[channelID].startTime = osdInfo[channelID].startTime;
      }*/
      for (unsigned int i = 0; i< m_vecOSDDBRootPath.size(); ++i)
      {
         long tmStart = osdInfo[channelID].startTime;
         CString dbRootPath = m_vecOSDDBRootPath[i];
         CString dbNameStart = GetDBName(dbRootPath, tmStart);
         GetOSDInDBOneTime( dbNameStart, channelID, osdInfo[channelID] );
         long tmEnd = tmStart + oneHour_s;
         while (tmEnd <= osdInfo[channelID].endTime)
         {  
            CString dbNameEnd = GetDBName(dbRootPath, tmEnd);         
            if (dbNameEnd != dbNameStart)
            {
               GetOSDInDBOneTime( dbNameEnd, channelID, osdInfo[channelID] );
            }
            dbNameStart = dbNameEnd;
            tmEnd = tmEnd + oneHour_s;
         }

         CString dbNameEnd = GetDBName(dbRootPath, osdInfo[channelID].endTime);         
         if (dbNameEnd != dbNameStart)
         {
            GetOSDInDBOneTime( dbNameEnd, channelID, osdInfo[channelID] );
         }
         osdInfo[channelID].startTime = osdInfo[channelID].endTime;
      }
      
   }
}


void CCheckOSD::GetOSDInDBOneTime(CString dbName, int channelID,  OSDInfo& osdInfo)
{

   sqlite3* pDB = NULL;
   if (! InitialDB(dbName, pDB) )
   {
      return;
   }
   
   char* szError = 0;
   int nRet;
   char** pResults = NULL;
   int nRows = 0;
   int nCols = 0;
   char sql[256];

   sprintf_s(sql, 256, "Select Time,Content from %s%d where Time>= %d and Time<%d order by Time",
      m_posTableName, channelID, osdInfo.startTime, osdInfo.endTime);

   nRet = sqlite3_get_table(pDB, sql, &pResults, &nRows, &nCols, &szError);

   int repeatCount = 0;
   while ( nRet == SQLITE_BUSY && repeatCount < 500)
   {
      Sleep(200);
      nRet = sqlite3_get_table(pDB, sql, &pResults, &nRows, &nCols, &szError);
      repeatCount++;
   }

   if (nRet == SQLITE_OK)
   {
      //for test
     /* CString strName;
      strName.Format(_T("ResultDB-%d.txt"),channelID);
      CString str;
      str.Format(_T("%d,%d"),osdInfo.startTime,osdInfo.endTime);
      WriteLog(m_helper.CStrA2CStrW(m_helper.GetPath(strName)),str);*/
      //
      for (int i = 1; i<= nRows; ++i )
      {           
         long time = _ttoi(pResults[i*nCols + 0]);
         CStringA strContent = pResults[i*nCols + 1];
         CStringA strOSDA = UTF_82ASCII( strContent );
         long timePOS = GetPOSTimeInOSD(strOSDA);

         ////for test
         //str.Format(_T("%d"),time);
         //WriteLog(m_helper.CStrA2CStrW(m_helper.GetPath(strName)),str);

         if ( 0 != timePOS )
         { 
            //OSD info push in map
            int nEnd = strOSDA.Find(_T("Pos_End"));
            if (nEnd != -1)
            {
               strOSDA = strOSDA.Mid(0, nEnd);
            }   

            ExtraInfo extraInfo;
            extraInfo.time = timePOS;
            extraInfo.strLog.Format( _T("%s,%s%d,%d,"), dbName, m_posTableName, channelID, time );
            extraInfo.strLog = extraInfo.strLog + strOSDA;
            osdInfo.mapOSD.insert(std::pair<CString,ExtraInfo>(strOSDA, extraInfo));
            if ( m_osdTime[channelID].startTime == 0 )
            {
               m_osdTime[channelID].startTime = timePOS;
            }


         }
         else
         {
            CString str;
            str.Format( _T("NotFindTimeInOSD-%s,%s%d,%d,"), dbName, m_posTableName, channelID, time );
            str = str + strOSDA;
            WriteLog(m_errorLogNameW, str);
         }

         //-------------------------------

      }
   }
   if ( nRet == SQLITE_BUSY)
   {
      CString str;
      str.Format(_T("sqlite3_get_table busy,DBName: %s, sql:%s ,"), dbName, sql);
      WriteLog(m_errorLogNameW, str);
   }
   if (pResults)
   {
      sqlite3_free_table(pResults);
      pResults = NULL;
   }
   if (pDB)
   {
      sqlite3_close(pDB);
   }
}

//-------------------------------------------------------
//--------Compare OSD between Vid and DB ---------------
//-------------------------------------------------------
void CCheckOSD::CompareOSD(OSDInfo* m_osdInfoVid, OSDInfo* m_osdInfoDB, int differentSize)
{
   
   CompareOSDOnce(m_osdInfoVid, m_osdInfoDB);

   std::multimap<CString, ExtraInfo>::iterator it;
   std::multimap<CString, ExtraInfo>::iterator tempIt;

   CString strLog;
   std::vector<CString> vecLogDBNotFind;
   std::vector<CString> vecLogVidNotFind;


   int index = 0;
   for (int i = 0; i< CHANNEL_COUNT; ++i )
   {
      int nSize = m_osdInfoVid[i].mapOSD.size() - differentSize;
      if ( nSize >= 0 )
      {
         index = 0;
         if ( m_endTime != 0 && 0 == m_osdTime[i].endTime)
            m_osdTime[i].endTime = m_endTime;

         for ( it = m_osdInfoVid[i].mapOSD.begin(); it != m_osdInfoVid[i].mapOSD.end(), index < nSize;  ++index)
         {	
            //it->second.strLog.Replace(_T("\r\n"),_T("\n"));
            //it->second.strLog.Replace(_T("\n"),_T(""));
            if ( 0 == differentSize )
            {
               long osdTime = it->second.time;
               if ( osdTime < m_osdTime[i].startTime || 
                  osdTime > m_osdTime[i].endTime )
               {
                  it = m_osdInfoVid[i].mapOSD.erase(it);
                  continue;
               }
            }
            vecLogDBNotFind.push_back(it->second.strLog);
            it = m_osdInfoVid[i].mapOSD.erase(it);
         }
      }

      nSize = m_osdInfoDB[i].mapOSD.size() - differentSize;
      if ( nSize >= 0 )
      {
         index = 0;
         for ( it = m_osdInfoDB[i].mapOSD.begin(); it != m_osdInfoDB[i].mapOSD.end(), index < nSize; ++index)
         {	
            if ( 0 == differentSize )
            {
               long osdTime = it->second.time;
               if ( osdTime < m_osdTime[i].startTime || 
                    osdTime > m_osdTime[i].endTime )
               {
                  it = m_osdInfoDB[i].mapOSD.erase(it);
                  continue;
               }
            }
            //it->second.strLog.Replace(_T("\r\n"),_T("\n"));
            //it->second.strLog.Replace(_T("\n"),_T(""));
            vecLogVidNotFind.push_back(it->second.strLog); 
            it = m_osdInfoDB[i].mapOSD.erase(it);
         }
      }
   }

   if ( vecLogDBNotFind.size() > 0 )
   {
      if (m_logFlag[3] == FALSE)
      {
         WriteLog(m_errorDBLog, _T("vidName,timeInPOS,startFrameIndex,endFrameIndex,OSD,"));
         m_logFlag[3] = TRUE;
      }
      WriteLog(m_errorDBLog, vecLogDBNotFind);
   }

   if ( vecLogVidNotFind.size() > 0 )
   {
      if (m_logFlag[2] == FALSE)
      {
         WriteLog(m_errorVidLog, _T("dbName,tableName,timeInTable,OSD,"));
         m_logFlag[2] = TRUE;
      }
      WriteLog(m_errorVidLog, vecLogVidNotFind);
   }
 
}

void CCheckOSD::CompareOSDOnce(OSDInfo* m_osdInfoVid, OSDInfo* m_osdInfoDB)
{
   //erase the same, leave the different
   std::multimap<CString,ExtraInfo>::iterator vidIt;
   std::multimap<CString,ExtraInfo>::iterator tempIt;

   CString str;
   CString strName;

   for (int i = 0; i< CHANNEL_COUNT; ++i)
   {
      if ( 0 == m_osdInfoVid[i].mapOSD.size())
      {
         continue;
      }
      for ( vidIt = m_osdInfoVid[i].mapOSD.begin(); vidIt != m_osdInfoVid[i].mapOSD.end(); )
      {	
         //CString str = vidIt->first;
         //long tm = vidIt->second.time;
         tempIt = m_osdInfoDB[i].mapOSD.find(vidIt->first);
         if( tempIt != m_osdInfoDB[i].mapOSD.end())
         {
				//for test
           /* strName.Format(_T("Result-%d.txt"),i);
            str.Format(_T("%d,%d"),i,vidIt->second.time);
            WriteLog(m_helper.CStrA2CStrW(m_helper.GetPath(strName)),str);
            WriteLog(m_helper.CStrA2CStrW(m_helper.GetPath(strName)),vidIt->first);*/
				//
            m_osdInfoDB[i].mapOSD.erase(tempIt);
            vidIt = m_osdInfoVid[i].mapOSD.erase(vidIt);
         } 
         else
            ++vidIt;
      }	
   }
}



//-------------------------------------------------------
//-------------------Other Function ---------------------
//-------------------------------------------------------
long CCheckOSD::GetPOSTimeInOSD(CString strOSD)
{
   long time = 0;
   int startPos = 0;
	
   if ( m_posType == Tzit )
   {
       CString strFind = _T("=======2");
      if ( -1 != (startPos = strOSD.Find( strFind )) )
      {

			CString strTime = strOSD.Mid(startPos + strFind.GetLength() - 1, 19 );
			int nYear, nMonth, nDate, nHour, nMin, nSec;
			try
			{
				sscanf_s(strTime, "%d/%d/%d %d:%d:%d", &nYear, &nMonth, &nDate, &nHour, &nMin, &nSec);
				CTime sTime(nYear, nMonth, nDate, nHour, nMin, nSec);
				time = (long)sTime.GetTime();
			}
			catch (CException* e)
			{
			}
		}
   }
   else if( m_posType == NEC )
   { 
      CString strFind = _T("ʱ:");

      if ( -1 != (startPos = strOSD.Find( strFind )) )
      {

			CString strTime = strOSD.Mid(startPos + strFind.GetLength(), 19 );
			int nYear, nMonth, nDate, nHour, nMin, nSec;
			try
			{
				sscanf_s(strTime, "%d/%d/%d %d:%d:%d", &nYear, &nMonth, &nDate, &nHour, &nMin, &nSec);
				CTime sTime(nYear, nMonth, nDate, nHour, nMin, nSec);
				time = (long)sTime.GetTime();
			}
			catch (CException* e)
			{

			}
		}
	}
   else
   {
      CString strFind = _T("ʱ:");

      if ( -1 != (startPos = strOSD.Find( strFind )) )
      {

         CString strTime = strOSD.Mid(startPos + strFind.GetLength(), 19 );
         int nYear, nMonth, nDate, nHour, nMin, nSec;
         try
         {
            sscanf_s(strTime, "%d-%d-%d %d:%d:%d", &nYear, &nMonth, &nDate, &nHour, &nMin, &nSec);
            CTime sTime(nYear, nMonth, nDate, nHour, nMin, nSec);
            time = (long)sTime.GetTime();
         }
         catch (CException* e)
         {

         }
      }
   }
   
   
   
   return time;
}

CString CCheckOSD::GetDBName(CString dbRootPath, long startTime)
{
   CTime tm;
   CString dbName;
   //D:\PV6\POSData\20150520\POS2015052015.db3
   CString posDBName;
   if (m_posType == Gemini)
      posDBName = _T("POSGemini");
   else
      posDBName = _T("POS");

   if ( 0 == startTime )
      tm = CTime::GetCurrentTime();
   else
      tm = CTime(startTime);
   
  
   dbName.Format(_T("%s%04d%02d%02d\\%s%04d%02d%02d%02d.db3"),
            dbRootPath, 
            tm.GetYear(), tm.GetMonth(), tm.GetDay(), posDBName,
            tm.GetYear(), tm.GetMonth(), tm.GetDay(), tm.GetHour());
   return dbName;
}

BOOL CCheckOSD::InitialDB(CString dbFilePath, sqlite3*& ppDb)
{
   CFileFind fFind;
   if ( FALSE == fFind.FindFile(dbFilePath) )
   {
      return FALSE;
   }    
   //int nRet = Sqlite_Open(dbFilePath, &m_pDB);
   int nRet = sqlite3_open(dbFilePath, &ppDb);
   if (nRet != SQLITE_OK)
   {
      const char* szError = sqlite3_errmsg(ppDb);
      return FALSE;
   }
   return TRUE;
}


CString CCheckOSD::GetPV6Path()
{
   CString pv6Path = _T("");
   HKEY hKEY;
   TCHAR szValue[256] = {0};
   LPCTSTR data_Set= _T("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\PowerVMS_is1");
   if (ERROR_SUCCESS == ::RegOpenKeyEx(HKEY_LOCAL_MACHINE,data_Set,0,KEY_READ,&hKEY))
   {
      DWORD dwSzType = REG_SZ;
      DWORD dwSize = sizeof(szValue);
      if (::RegQueryValueEx(hKEY,_T("InstallLocation"), 0, &dwSzType, (LPBYTE)&szValue, &dwSize) == ERROR_SUCCESS)
      {      
         CTime tm = CTime::GetCurrentTime();
         pv6Path.Format(_T("%s"), szValue);
      }
      ::RegCloseKey(hKEY);
   }
   return pv6Path;
}

void CCheckOSD::GetRecordDBDiskList()
{
   m_vecRecordDBPath.clear();
   TCHAR buf[100]; 
   DWORD len = GetLogicalDriveStrings(sizeof(buf)/sizeof(TCHAR),buf);
   for (TCHAR* s=buf; *s; s+=_tcslen(s)+1) 
   { 
      CString sDrivePath = s;
      sDrivePath.Format(_T("%sTape\\RecordTape.db3"),s);

      if( _access(sDrivePath,0) != -1 )
         m_vecRecordDBPath.push_back(sDrivePath);
   } 
}

BOOL CCheckOSD::GetPV6DBPath()
{
   m_vecOSDDBRootPath.clear();
   TCHAR buf[100]; 
   DWORD len = GetLogicalDriveStrings(sizeof(buf)/sizeof(TCHAR),buf);
   for (TCHAR* s=buf; *s; s+=_tcslen(s)+1) 
   { 
      CString sDrivePath = s;
      sDrivePath.Format(_T("%sPV6\\POSData\\"),s);

      if( _access(sDrivePath,0) != -1 )
         m_vecOSDDBRootPath.push_back(sDrivePath);
   } 
   unsigned int nSize = m_vecOSDDBRootPath.size();
   if ( 0 == nSize )
   {
      CString str = _T("[error]Not Find PV6DB  of In All Disk\r\n");
      WriteLog(m_errorVidLog, str);
      return FALSE;
   }
   return TRUE;
}


void CCheckOSD::GetLogName()
{
   SYSTEMTIME st = {0};
   GetLocalTime(&st);
   CString logName;
   CString logPathName;

   logName.Format(_T("%s-%04d-%02d-%02d-%02d-%02d-%02d.csv"),LOG_NAME,st.wYear,st.wMonth,st.wDay,
      st.wHour,st.wMinute,st.wSecond);
   m_logNameW = m_helper.CStrA2CStrW(m_helper.GetPath(logName));
	WriteLog(m_logNameW, _T("vidName, minDelay(s), maxDelay(s),"));
   
   logName.Format(_T("%s-%04d-%02d-%02d-%02d-%02d-%02d.csv"),ERROR_LOG_NAME,st.wYear,st.wMonth,st.wDay,
      st.wHour,st.wMinute,st.wSecond);
   m_errorLogNameW = m_helper.CStrA2CStrW(m_helper.GetPath(logName));

   //2015-06-01
   logName.Format(_T("%s-%04d-%02d-%02d-%02d-%02d-%02d.txt"),NOT_FIND_IN_VID,st.wYear,st.wMonth,st.wDay,
      st.wHour,st.wMinute,st.wSecond);
   m_errorVidLog = m_helper.CStrA2CStrW(m_helper.GetPath(logName));
   
   logName.Format(_T("%s-%04d-%02d-%02d-%02d-%02d-%02d.txt"),NOT_FIND_IN_DB,st.wYear,st.wMonth,st.wDay,
      st.wHour,st.wMinute,st.wSecond);
   m_errorDBLog = m_helper.CStrA2CStrW(m_helper.GetPath(logName));
}

void CCheckOSD::WriteLog(CStringW logNameW, std::vector<CString> vecStr)
{
   
   std::wofstream logFile;
   CString  separator = _T(",");
   logFile.open(logNameW, std::ios::app);

   for (unsigned int i = 0; i< vecStr.size(); ++i)
   {
      logFile<<vecStr[i]<<std::endl;
   }
   logFile.close();
}

void CCheckOSD::WriteLog(CStringW logNameW, CString str)
{

   std::wofstream logFile;
   CString  separator = _T(",");
   logFile.open(logNameW, std::ios::app);

  
   logFile<<str<<std::endl;
   logFile.close();
}

BOOL CCheckOSD::ReagConfig()
{
	int nType = GetPrivateProfileInt(_T("POS_TYPE"), _T("pos_type"), 0, m_helper.GetPath(_T("CheckPOSInVID.ini")));
	m_posType = (POS_TYPE)nType;
   if (m_posType == Gemini)
   {
      m_posHeadIndex = POS_HEAD_INDEX_GEMINI;
      m_posTableName = TABLE_NAME_Gemini;
   }
   else
   {
      m_posHeadIndex = POS_HEAD_INDEX;
      m_posTableName = TABLE_NAME;
   }

  /* CString strDisk;
   GetPrivateProfileString(_T("POS_DB_PATH"),_T("disk"),_T(""),strDisk.GetBuffer(256), 256, m_helper.GetPath(_T("CheckPOSInVID.ini")));
   strDisk.ReleaseBuffer();
   if ( strDisk != _T(""))
   {
      m_dbRootPath.Format(_T("%sPV6\\POSData\\"), strDisk);
   }
   else
   {
      WriteLog(m_errorLogNameW, _T("Read POS_DB_PATH error in CheckPOSInVID.ini!"));
      return FALSE;
   }
	  */
   CString strChannel;
	CString strChannelID;
	std::vector<int> vecChannelID;
	GetPrivateProfileString(_T("POS_CHANNEL"),_T("channelID"),_T(""),strChannel.GetBuffer(256), 256, m_helper.GetPath(_T("CheckPOSInVID.ini")));
   strChannel.ReleaseBuffer();
   int index = 0;
	int nStart = 0;
	int nSize = strChannel.GetLength();
   int channelCount = 0;
   m_vecOSDChannelID.clear();
	while( index < nSize)
	{
		index = strChannel.Find(_T(","), nStart);
		if( -1 != index )
      {
			strChannelID = strChannel.Mid(nStart, index - nStart);
         nStart = index + 1;

      }
      else if ( nStart < strChannel.GetLength() )
      {
         strChannelID = strChannel.Mid(nStart);
         index = nSize;
      }	
      else
         break;
		int channelID = _ttoi(strChannelID) - 1;
      if ( channelID >=0 )
      {
         m_vecOSDChannelID.push_back(channelID);
         channelCount++;
      }
	}
   if ( 0 == channelCount )
   {
      WriteLog(m_errorLogNameW, _T("Read POS_CHANNEL error in CheckPOSInVID.ini!"));
      return FALSE;
   }
   return TRUE;
}


LONG CCheckOSD::CheckTime( CString fileName )
{
   LONG time = 0;

   fileName = fileName.Mid( fileName.Find( _T("2")) , 10 );
   int nYear, nMonth, nDate, nHour;
   try
   {
      sscanf_s(fileName, "%04d%02d%02d%02d", &nYear, &nMonth, &nDate, &nHour);
      CTime sTime(nYear, nMonth, nDate, nHour, 0, 0 );
      time = (LONG)sTime.GetTime();
   }
   catch (CException* e)
   {
   }
   return time;
}


CString CCheckOSD::UTF_82ASCII(CString& strUtf8Code) 
{ 
   CString strRet(""); 	
   CStringW wStr = m_helper.CStrA2CStrW(CP_UTF8, strUtf8Code); 	
   strRet = m_helper.CStrW2CStrA(wStr); 
   return strRet; 
} 

BOOL CCheckOSD::IsCheckDone()
{
   std::map <int, CString>::iterator it;
   bool flag = false;
   for ( unsigned int i = 0; i< m_vecOSDChannelID.size(); ++i )
   {
      int channelID = m_vecOSDChannelID[i];
      if (m_isCheckDone[channelID])
      {
         flag = true;
         break;
      }
   }
   return flag;
}