#pragma once
#include "..\sqlite\sqlite3.h"
#include "..\VidParse\PV6VIDTestSDK.h"
#include <vector>
#include <map>
#include <fstream>
#include "PublicHelper.h"
#define CHANNEL_COUNT 32


struct ExtraInfo
{
	CString strLog;
	long time;
};

typedef struct OSD_TIME_OF_CHANNEL
{
   long startTime;
   long endTime;
}OSDTimeOfChannel;

typedef struct OSD_INFO
{
   int channelID;
   long startTime;
   long endTime;
   std::multimap<CString,ExtraInfo> mapOSD;//OSD,(time,log)
}OSDInfo;

enum POS_TYPE
{
	Tzit = 0,
   NEC = 1,
   Gemini = 2	
};


class CCheckOSD
{
public:
   CCheckOSD(void);
   ~CCheckOSD(void);
   BOOL Inital();
   void StartCheck();
   void StopCheck();
   long m_startTime;
   long m_endTime;
   HWND m_hwnd;
private: 

   static UINT CALLBACK Check( LPVOID pParam );
   void Prepare();
   void GetOSDInVid(CString* headStr, long* headFrameTime, OSDInfo* osdInfoVid, OSDInfo* osdInfoDB);
   CString GetOSDInOneVid(CString vidPathName, CString& headStr, 
                        long& headFrameTime, OSDInfo& osdInfoVid, OSDInfo& osdInfoDB, 
                        OSDTimeOfChannel& osdTime, bool& isCheckDone);
   CString GetOSDInVidDetail(CString vidName,
                          char** pOSDInfo,
                          BYTE** pFrameInfo,
                          unsigned long lTotalFrameCount, 
                          CString& headStr, 
                          long& headFrameTime,
                          OSDInfo& osdInfoVid,
                          OSDTimeOfChannel& osdTime,
                          bool& isCheckDone);


   void GetOSDInDB(OSDInfo* osdInfo);
   void GetOSDInDBOneTime(CString dbaName, int channelID, OSDInfo& osdInfo );

   void CompareOSD(OSDInfo* m_osdInfoVid, OSDInfo* m_osdInfoDB, int differentSize);
   void CompareOSDOnce(OSDInfo* m_osdInfoVid, OSDInfo* m_osdInfoDB);

   long GetPOSTimeInOSD(CString strOSD);
   CString GetDBName(CString dbRootPath, long startTime = 0);
   BOOL InitialDB(CString dbFilePath, sqlite3*& ppDb);

   CString GetPV6Path();
   void GetRecordDBDiskList();
   BOOL GetPV6DBPath();

   void GetLogName();
   void WriteLog(CStringW logNameW, std::vector<CString> vecStr);
   void WriteLog(CStringW logNameW, CString str);

	BOOL ReagConfig();
   LONG CheckTime( CString fileName );
   CString UTF_82ASCII(CString& strUtf8Code);
   BOOL IsCheckDone();

   BOOL m_exitThread;
	BOOL m_isExitThread;
   //CString m_dbRootPath;
   std::vector<int> m_vecOSDChannelID;
   std::vector<CString> m_vecRecordDBPath;
   std::vector<CString> m_vecOSDDBRootPath;
   PublicHelper m_helper;
   CStringW m_logNameW;
   CStringW m_errorLogNameW;
   CStringW m_errorVidLog;
   CStringW m_errorDBLog;

   OSDInfo m_osdInfoVid[CHANNEL_COUNT];
   OSDInfo m_osdInfoDB[CHANNEL_COUNT];
   OSDTimeOfChannel m_osdTime[CHANNEL_COUNT];
   //OSDTimeOfChannel m_osdTimeVid[CHANNEL_COUNT];
   long m_lastTime[CHANNEL_COUNT];
   bool m_isCheckDone[CHANNEL_COUNT];

	POS_TYPE m_posType;
   CString m_posHeadIndex;
   CString m_posTableName;
   BOOL m_logFlag[4];
   BOOL m_isStartCheck;
   //need read DB Path,D:\PV6\POSData\20150520
};
