#ifndef _PUBLIC_HELPER_H
#define _PUBLIC_HELPER_H

class PublicHelper
{
public:
   CString GetPath(CString fileName)
   {
      TCHAR exeFullPath[MAX_PATH]; // Full path
      TCHAR path[MAX_PATH] = {0};
      int n=GetModuleFileName(NULL,exeFullPath,MAX_PATH);
      if (n>0)
      {
         while (exeFullPath[n]!='\\')
         {
            n--;			
         }
         memset(path,0,MAX_PATH);
         memcpy(path,exeFullPath, n*sizeof(TCHAR));
      }
      CString resultPath;
      resultPath.Format(_T("%s\\%s"),path,fileName);
      return resultPath;
   }

   BOOL IsFileExist(CString fileName)
   {
      WIN32_FIND_DATA   FindFileData;  
      HANDLE  hFind;  
      hFind = FindFirstFile(fileName,&FindFileData);  
      return (hFind == INVALID_HANDLE_VALUE?FALSE:FindClose(hFind)); 
   }

   CStringA CStrW2CStrA(const CStringW &cstrSrcW )
   {
      CStringA cstrDestA = "";
      DWORD dwMinSize = WideCharToMultiByte(CP_OEMCP , NULL , (LPCWSTR)cstrSrcW , -1, NULL, 0, NULL , FALSE );
      if (dwMinSize > 0)
      {
         char* astr = new char[ dwMinSize];
         memset( astr, 0, dwMinSize* sizeof( char));
         WideCharToMultiByte( CP_OEMCP, NULL, (LPCWSTR)cstrSrcW, -1, astr, dwMinSize, NULL , FALSE );  
         cstrDestA = astr;
         delete[] astr;
      }
      return cstrDestA;
   }

   CStringW CStrA2CStrW(const CStringA &cstrSrcA)
   {
      int len = MultiByteToWideChar(CP_ACP, 0, LPCSTR(cstrSrcA), -1, NULL, 0);
      wchar_t *wstr = new wchar_t[len];
      memset(wstr, 0, len*sizeof(wchar_t));
      MultiByteToWideChar(CP_ACP, 0, LPCSTR(cstrSrcA), -1, wstr, len);
      CStringW cstrDestW = wstr;
      delete[] wstr;
      return cstrDestW;
   }

   CStringW CStrA2CStrW(int cpType,const CStringA &cstrSrcA)
   {
      int len = MultiByteToWideChar(cpType, 0, LPCSTR(cstrSrcA), -1, NULL, 0);
      wchar_t *wstr = new wchar_t[len];
      memset(wstr, 0, len*sizeof(wchar_t));
      MultiByteToWideChar(cpType, 0, LPCSTR(cstrSrcA), -1, wstr, len);
      CStringW cstrDestW = wstr;
      delete[] wstr;
      return cstrDestW;
   }

   int Sqlite_Open (CStringW dbName , sqlite3 ** db )
   {
      int nlen=0;
      char cpath[ MAX_PATH];
      nlen= WideCharToMultiByte(CP_UTF8 , 0, (LPCWSTR )dbName , -1, 0, 0, 0, 0);
      WideCharToMultiByte(CP_UTF8 , 0, (LPCWSTR )dbName , -1, cpath, nlen , 0, 0);
      return sqlite3_open(cpath , db );
   }
};

#endif